(* Ce programme ne fait que lire, par tentatives de 1024 octets,
 * et logue les lectures. *)

let time =
  let t0 = Unix.gettimeofday () in
    fun () -> Unix.gettimeofday () -. t0

let () =
  let buf = String.create 1024 in
  let rec loop () =
    Scheduler.read Unix.stdin buf 0 1024
      (fun j ->
         Printf.printf "%.2f: read %d bytes.\n%!" (time ()) j ;
         if j > 0 then [loop ()] else exit 0)
  in
    Scheduler.run (fun () -> [loop ()])
