let perror (e,f,s) =
  if s = "" then
    Printf.printf "%s in %s.\n" (Unix.error_message e) f
  else
    Printf.printf "%s in %s: %s.\n" (Unix.error_message e) f s

let default_on_error fd e =
  begin match e with
    | Unix.Unix_error (e,f,s) -> perror (e,f,s)
    | e -> Printf.printf "Unknown error\n"
  end ;
  `Noop

let read fd s i n ?(on_error=default_on_error fd) k : task =
  let f () =
    match try `OK (Unix.read fd s i n) with e -> `KO e with
      | `OK e -> k e
      | `KO e -> on_error e
  in
    `Read (fd, f)
